#include <stdio.h>
#include <pthread.h>
#include <stdlib.h>
#define _GNU_SOURCE
#include <fcntl.h>
#include <unistd.h>
#include <string.h> 
#include <stdatomic.h>
#define MAX_SIZE 10

#define ALLOTMEMORY (KV *)malloc(sizeof(KV)*MAX_SIZE)
// static unsigned _Atomic active[10];
typedef enum{
    FALSE,TRUE
}bool;

struct KV{
    char *key;
    char *value;
    bool valid;
    bool modified;
    int lock;
    // unsigned _Atomic lock;
};

int lockers[10];
typedef struct KV KV;

struct queue{
    char *key;
    struct queue *next;
};

typedef struct queue queue;

KV *array[MAX_SIZE];
queue *qu = NULL;
queue *last=NULL;

// int compare_and_swap(int* reg, int oldval, int newval)
// {
//   ATOMIC();
//   int old_reg_val = *reg;
//   if (old_reg_val == oldval)
//      *reg = newval;
//   END_ATOMIC();
//   return old_reg_val;
// }

 bool cas( int *p, int old, int new ) {
    if( *p == old ) {
      *p = new;
      return TRUE;
    } else {
      return FALSE;
    }
  }

void remove_element_from_deque(char *key)
{
    queue *present = qu , *previous=NULL;
    while(present->next != NULL)
    {
        if(present->key == key)
        {
            if(previous == NULL)
                qu = qu->next;
            if(last == present)
                last = previous;
            if(previous)
                previous->next = present->next;
            free(present);
            return;
        }
        previous = present;
        present = present->next;
    }
}

void insert_into_queue(char *key)
{
    queue *temp = (queue *)malloc(sizeof(queue));
    temp->key = key;
    temp->next = NULL;
    if(qu == NULL)
    {
        qu = temp;
        last = temp;
    }
    else
    {
        last->next = temp;
        last = temp;
    }
}

int find_empty_location()
{
    for(int i=0;i<MAX_SIZE;i++)
    {
        if(array[i]->valid == FALSE)
            return i;
    }
}

void delet(char *key)
{
    for(int i=0;i<MAX_SIZE;i++)
    {
        if(array[i]->key == key)
        {
            while(atomic_exchange_explicit(&(array[i]->lock),1,0) == 1);
            remove_element_from_deque(key);
            array[i]->valid = FALSE;
            atomic_exchange_explicit(&(array[i]->lock),0,1);
            break;
        }
    }
    //TODO remove key from file also
}

void put(char *key, char *value)
{
    int indx=-1;
    for(int i=0;i<MAX_SIZE;i++)
    {
        if(array[i]->key == key)
        {
            indx = i;
            remove_element_from_deque(key);
            break;
        }
    }
    
    if(indx == -1)
    {
        indx = find_empty_location();
        // TODO should write to file if modified is true
        // replacment from cache
    }

    while(atomic_exchange_explicit(&(array[indx]->lock),1,0) == 1);
    array[indx]->key = key;
    array[indx]->value = value;
    array[indx]->valid = TRUE;
    array[indx]->modified = TRUE;
    insert_into_queue(key);
    atomic_exchange_explicit(&(array[indx]->lock),0,1);
}

char* get(char *key)
{
    for(int i=0;i<MAX_SIZE;i++)
    {
        if(array[i]->key == key)
        {
            while(atomic_exchange_explicit(&(array[i]->lock),1,0) == 1);
            remove_element_from_deque(key);
            insert_into_queue(key);
            atomic_exchange_explicit(&(array[i]->lock),0,1);
            return array[i]->value;
        }
    }
    return (char *)"NOT FOUND";
}

int main()
{
    int i=0;
    for(int j=0;j<MAX_SIZE;j++)
    {
        array[j] = (KV *)malloc(sizeof(KV));
        array[j]->valid = FALSE;
        array[j]->lock = 0;
    }
    char key1[250]="Hello world1";
    char value1[256] = "THIS IS  Vlaue1";

    char key2[250]="Hello world2";
    char value2[256] = "THIS IS  Vlaue2";

    char key3[250]="Hello world3";
    char value3[256] = "THIS IS  Vlaue3";

    char key4[250]="Hello world4";
    char value4[256] = "THIS IS  Vlaue4";

    char key5[250]="Hello world5";
    char value5[256] = "THIS IS  Vlaue5";

    char key6[250]="Hello world6";
    char value6[256] = "THIS IS  Vlaue6";


    KV  *temp1 = (KV *)malloc(sizeof(KV));
    KV  *temp2 = (KV *)malloc(sizeof(KV));
    KV  *temp3 = (KV *)malloc(sizeof(KV));
    KV  *temp4 = (KV *)malloc(sizeof(KV));
    KV  *temp5 = (KV *)malloc(sizeof(KV));
    KV  *temp6 = (KV *)malloc(sizeof(KV));

    temp1->key = key1;
    temp1->value = value1;
    temp1->valid = TRUE;

    temp2->key = key2;
    temp2->value = value2;
    temp2->valid = TRUE;

    temp3->key = key3;
    temp3->value = value3;
    temp3->valid = TRUE;

    temp4->key = key4;
    temp4->value = value4;
    temp4->valid = TRUE;

    temp5->key = key5;
    temp5->value = value5;
    temp5->valid = TRUE;

    temp6->key = key6;
    temp6->value = value6;
    temp6->valid = TRUE;


    array[i++] = (temp1);
    array[i++] = (temp2);
    array[i++] = (temp3);
    array[i++] = (temp4);
    array[i++] = (temp5);
    array[i++] = (temp6);

    qu = (queue *)malloc(sizeof(queue));
    qu->key = temp1->key;
    qu->next = NULL;

    queue *te = qu;
    te->next = (queue *)malloc(sizeof(queue));
    te = te->next;
    te->key = temp1->key;
    te->next = NULL;

    te->next = (queue *)malloc(sizeof(queue));
    te = te->next;
    te->key = temp2->key;
    te->next = NULL;

    te->next = (queue *)malloc(sizeof(queue));
    te = te->next;
    te->key = temp3->key;
    te->next = NULL;


    te->next = (queue *)malloc(sizeof(queue));
    te = te->next;
    te->key = temp4->key;
    te->next = NULL;

    te->next = (queue *)malloc(sizeof(queue));
    te = te->next;
    te->key = temp5->key;
    te->next = NULL;
    last = te;

    printf("%s " " %s\n", array[0]->key, array[0]->value);
    printf("%s " " %s\n", array[1]->key, array[1]->value);
    printf("%s " " %s\n", array[2]->key, array[2]->value);
    printf("%s " " %s\n", array[3]->key, array[3]->value);
    printf("%s " " %s\n", array[4]->key, array[4]->value);
    printf("%s " " %s\n", array[5]->key, array[5]->value);

    printf("%s\n",get(array[5]->key));
    put(array[5]->key, (char *)"This is a good");
    printf("%s\n",get(array[5]->key));

    delet(array[5]->key);
        
    delet(array[0]->key);

    put((char *)"Hello World7", (char *)"THis is vaue7");

    printf("%s %s\n",array[0]->key, array[0]->value);

    return 0;
}
